Chuyển đến nội dung
Diễn đàn CADViet
ssg

Hướng dẫn lập trình Lisp

Các bài được khuyến nghị

Hàm tạo mảng

(vlax-make-safearray type '(l-bound . u-bound) ['(lbound . u-bound)...)]

với '(l-bound . ubound) :là chỉ số dưới và trên của 1 chiều.

- Chỉ số (Index) có thể bắt đầu bằng 0, 1 hay 1 số nguyên nào đó.

 

Vd: để tạo mảng 1 chiều có 3 ptử kiểu vlax-vbDouble, 2 dòng lệnh sau cho kết quả như nhau :

(vlax-make-safearray vlax-VBDouble (cons 0 2)) -> chỉ số dưới là 0, chỉ số trên là 2

(vlax-make-safearray vlax-VBDouble (cons 1 3)) -> chỉ số dưới là 1, chỉ số trên là 3

 

Như vậy :

(vlax-make-safearray vlax-vbDouble (cons 0 (1- (length Lpoint)))

sẽ tạo mảng 1 chiều có (length Lpoint) ptử kiểu vlax-vbDouble, với chỉ số dưới là 0, chỉ số trên là (1- (length Lpoint))

 

dĩ nhiên bạn vẫn có thể khai báo như sau :

(vlax-make-safearray vlax-vbDouble (cons 1 (length Lpoint))

sẽ tạo mảng 1 chiều có (length Lpoint) ptử kiểu vlax-vbDouble, với chỉ số dưới là 1, chỉ số trên là (length Lpoint)

 

Vấn đề Nhập 3 điểm nhưng chỉ có 2 segments là do bạn chưa ADD điểm p vào Lpoint

(setq Lpoint (list p))

nên trong Lpoint chỉ có các điểm p2.

 

Gửi bạn Lisp sửa đổi và vẽ “khung xương hình hài” của spline như ý của thiep

(defun c:vespl (/ end lpoint ms p p1 p2 start)
 (defun mkSpline (spc lst t1 t2 / lst)
   (setq lst (apply 'append lst))
   (vla-AddSpline spc
     (vlax-make-variant
(vlax-safearray-fill
  (vlax-make-safearray
    vlax-VBDouble (cons 0 (1- (length lst)))) lst))
     (vlax-3D-point t1)
     (vlax-3D-point t2)))

 (setq	MS (vla-get-ModelSpace (vla-get-activeDocument (vlax-get-acad-object)) )
p  (getpoint "\n Nhap diem :")
p1 p
Lpoint (list p))
 (while (setq p2 (getpoint p "\n Nhap diem tiep theo :"))
   (grdraw p p2 8) 
   (setq Lpoint (cons p2 Lpoint)
  p	 p2 )  )
 (setq start (getpoint p1 "\n StartTangent :")
end (getpoint p "\n EndTangent :"))

 (or start (setq start '(0 0 0)))
 (or end (setq end '(0 0 0)))
 (redraw)
 (mkSpline ms Lpoint start end)
 (princ)
)

Cảm ơn anh gia_bach nhiều lắm. Tue_NV hiểu ra vấn đề. Nhưng còn 1 chổ vướng mắc, rất mong được giải thích :

 

(defun mkSpline (spc lst t1 t2 / lst)

(setq lst (apply 'append lst))

(vla-AddSpline spc

(vlax-make-variant

(vlax-safearray-fill

(vlax-make-safearray

vlax-VBDouble (cons 0 (1- (length lst)))) lst))

(vlax-3D-point t1)

(vlax-3D-point t2)))

 

-> Trong hàm mkSpline có 2biến lst : một biến toàn cục, 1 biến cục bộ

(defun mkSpline (spc lst t1 t2 / lst)-> tại sao lại có 2 biến này ạ. Em nghĩ chỉ 1 biến là đủ. Có ảnh hưởng chi không anh? Em bỏ biến cục bộ lst đi thì Lisp vẫn chạy bình thường ạ. Không có vấn đề gì?

 

Một lần nữa. Rất cảm ơn anh gia_bach và bác Thiep đã giải thích giúp cho Tue_NV về vấn đề Mảng trong Lisp.

Thành thật biết ơn.

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
...............

(defun mkSpline (spc lst t1 t2 / lst)

(setq lst (apply 'append lst))

...............................

 

-> Trong hàm mkSpline có 2biến lst : một biến toàn cục, 1 biến cục bộ

(defun mkSpline (spc lst t1 t2 / lst)-> tại sao lại có 2 biến này ạ. Em nghĩ chỉ 1 biến là đủ. Có ảnh hưởng chi không anh? Em bỏ biến cục bộ lst đi thì Lisp vẫn chạy bình thường ạ. Không có vấn đề gì?

...............

Trong truờng hợp này bỏ biến cục bộ lst đi cũng không ảnh huởng đến hòa bình thế giới.

Chỉ khác ở chỗ sau khi hoàn thành lệnh vespl : có tồn tại biến lst là danh sách các số thực hay không ?

(apply 'append danh_sach_diem)) -> danh_sach_so_thuc

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác

Mình có 1 lisp tạo các dạng đường và chử theo từng nội dung line và text, như lớp vẻ nhà, vẽ thủy hệ, đường, tên sông , tên chữ chủ dụng dụng.

Muốn nhờ anh hướng dẫn cho lisp chọn các lệnh, như vẽ nhà thì lớp đó là lớp hiện hành và thực hiện đúng theo các đường nét đã thiết lập trước, text cũng vậy.

Rất mong được các anh chỉ giúp

http://www.cadviet.com/upfiles/2/taolop03.lsp

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
Tự tay mình lập một chương trình Lisp có gì khác so với nhờ ai đó làm? Chưa cần xét kết quả, điểm khác nhau rất cơ bản là bạn sẽ có được cái cảm giác rất là khoái chí (không thể diễn tả) khi chạy thử chương trình.

Ssg lập topic này không ngoài mục đích tạo điều kiện cho các bạn tự mình tìm hiểu và khám phá cái cảm giác "khoái chí không thể diễn tả" nói trên.

Với tinh thần "Share is Receive", ssg cũng mong các bạn đã thành thạo Lisp quan tâm giúp đỡ các bạn mới để cộng đồng Lisp của CadViet ngày càng đông vui và tạo được nhiều chương trình hữu ích.

Để bắt đầu, ssg post lại một bài viết cũ, nhưng có lẽ vẫn còn mới đối với một số bạn. Hy vọng sẽ giúp được chút gì đó cho các bạn mới tiếp cận với Lisp:

 

http://www.cadviet.com/upfiles/Relax_1.zip

 

Download, giải nén rồi đọc file *.doc

 

mình đang gặp fải 1 vấn đề là có 1 loại k biết fải virut k nó vào k làm hỏng cái gi ngoài cad làm hỏng lisp hỏng hết cad k vẽ đc.mở lên k tắt đc,hỏng cả lệnh H luôn.có bạn nào khắc fục đc k.gỡ cài lại cũng k đc nốt,k muôn fải cài lại máy,mình dùng laptop.thanks

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
......

Xin được đặt lại bài toán ở dạng tương đương:

Cho một tập điểm S. Hãy xác định đa giác lồi P, chứa toàn bộ các điểm thuộc S, mỗi đỉnh của P là 1 điểm thuộc S.

Xem hình dưới đây:

bound1.jpg

Thuật giải như sau:

1- Xác định điểm có tung độ nhỏ nhất trong các điểm thuộc S -> đặt là điểm A. Chắc chắn A là 1 điểm thuộc P

2- Từ A, xác định angle đến tất cả các điểm còn lại của S. Điểm ứng với angle nhỏ nhất chính là điểm tiếp theo của đa giác P theo chiều ngược kim đồng hồ (điểm B trên hình).

3- Xoay hệ trục tọa độ như hình dưới:

bound2.jpg

Tương tự như bước 2, điểm tiếp theo C là điểm có angle nhỏ nhất trong hệ tọa độ này

4- Tiếp tục làm tương tự cho đến khi quay về lại điểm A

Kết quả cuối cùng là một tập điểm có thứ tự, xác định đa giác lồi P, thỏa mãn điều kiện bài toán.

Tue_NV đã thử làm bài toán của bác ssg và đã hoàn thành được bước 1 và bước 2

Còn bước 3 và bước 4 thì Tue_NV đã thử nhưng không được. Cái không được chính là vòng lặp để vòng lặp cuối thì trở lại điểm A thì dừng lại. Cứ mỗi lần xoay hệ trục thì toạ độ thì toạ độ nó lại biến đổi, mình biết hàm trans, nó liên quan đến chuyện này nhưng chưa biết cách áp dụng nó cho đúng. Vì thế chưa tạo được vòng lặp. Mong các bác trên diễn đàn có thể bớt 1 chút thời gian giải thích rõ hơn về hàm trans và áp dụng vào code dưới đây như thế nào để có thể giải quyết được bài toán này một cách trọn vẹn

Dưới đây là code :

(defun c:dglo(/ ss tap_ins pd pc goc goc_base)
 (setq ss (ssget '((0 . "POINT"))) tap_ins (list))
 (setq ss (mapcar 'vlax-ename->vla-object (vl-remove-if 'listp (mapcar 'cadr (ssnamex ss)))))
 (setq tap_ins (mapcar '(lambda (x) (vlax-get x 'Coordinates)) ss))
 (setq tap_ins (mapcar '(lambda (x) (trans x 0 1)) tap_ins))
 (setq tap_ins (vl-sort tap_ins
		 '(lambda (x y)
		    (			  )
	)
 )

 (setq pd (car tap_ins) pcheck nil)
 (setq goc_min (* 2 pi))
 (foreach x tap_ins
   (if (not (equal pd x))
      (progn
    	 (setq goc (angle pd x))
 (if (	   (setq goc_min goc)
   (setq pcheck x)
 ))
     	) 
   )
 );foreach
 	(command "LINE" pd pcheck "")
 (princ)
 )

Rất mong sự hướng dẫn của các bác.

Tue_NV xin chân thành cảm ơn.

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
Tue_NV đã thử làm bài toán của bác ssg và đã hoàn thành được bước 1 và bước 2

Còn bước 3 và bước 4 thì Tue_NV đã thử nhưng không được. Cái không được chính là vòng lặp để vòng lặp cuối thì trở lại điểm A thì dừng lại. Cứ mỗi lần xoay hệ trục thì toạ độ thì toạ độ nó lại biến đổi, mình biết hàm trans, nó liên quan đến chuyện này nhưng chưa biết cách áp dụng nó cho đúng. Vì thế chưa tạo được vòng lặp. Mong các bác trên diễn đàn có thể bớt 1 chút thời gian giải thích rõ hơn về hàm trans và áp dụng vào code dưới đây như thế nào để có thể giải quyết được bài toán này một cách trọn vẹn

Dưới đây là code :

(defun c:dglo(/ ss tap_ins pd pc goc goc_base)
 (setq ss (ssget '((0 . "POINT"))) tap_ins (list))
 (setq ss (mapcar 'vlax-ename->vla-object (vl-remove-if 'listp (mapcar 'cadr (ssnamex ss)))))
 (setq tap_ins (mapcar '(lambda (x) (vlax-get x 'Coordinates)) ss))
 (setq tap_ins (mapcar '(lambda (x) (trans x 0 1)) tap_ins))
 (setq tap_ins (vl-sort tap_ins
		 '(lambda (x y)
		    (< (cadr x) (cadr y))
		  )
	)
 )

 (setq pd (car tap_ins) pcheck nil)
 (setq goc_min (* 2 pi))
 (foreach x tap_ins
   (if (not (equal pd x))
      (progn
    	 (setq goc (angle pd x))
 (if (< goc goc_min) (progn
   (setq goc_min goc)
   (setq pcheck x)
 ))
     	) 
   )
 );foreach
 	(command "LINE" pd pcheck "")
 (princ)
 )

Rất mong sự hướng dẫn của các bác.

Tue_NV xin chân thành cảm ơn.

Theo Thiep, nếu không xoay thì tìm điểm kế tiếp vẫn được mà. Từ điểm B vừa tìm được vẫn tìm được điểm C.... Cứ thế cho đến khi điểm cuối trùng lại điểm A thì dừng.

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
Theo Thiep, nếu không xoay thì tìm điểm kế tiếp vẫn được mà. Từ điểm B vừa tìm được vẫn tìm được điểm C.... Cứ thế cho đến khi điểm cuối trùng lại điểm A thì dừng.

Khi xoay hệ toạ độ UCS ta mới tìm được góc góc angmin. Ứng với góc angmin ta tìm được 1 điểm C -> thực hiện vòng lặp cho đến khi nào nó quay về điểm A (điểm tìm được đầu tiên).

Còn không xoay UCS thì Tue_NV bó tay, không biết làm cách nào?

Tue_NV đã thử làm bài toán của bác ssg và đã hoàn thành được bước 1 và bước 2

Còn bước 3 và bước 4 thì Tue_NV đã thử nhưng không được. Cái không được chính là vòng lặp để vòng lặp cuối thì trở lại điểm A thì dừng lại. Cứ mỗi lần xoay hệ trục thì toạ độ thì toạ độ nó lại biến đổi, mình biết hàm trans, nó liên quan đến chuyện này nhưng chưa biết cách áp dụng nó cho đúng. Vì thế chưa tạo được vòng lặp. Mong các bác trên diễn đàn có thể bớt 1 chút thời gian giải thích rõ hơn về hàm trans và áp dụng vào code dưới đây như thế nào để có thể giải quyết được bài toán này một cách trọn vẹn

Code đẫ được Tue_NV thể hiện ở bài viết trên (bài viết số 190)

Mong được sự giúp đỡ của các bác.

Tue_NV xin cảm ơn.

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
Khi xoay hệ toạ độ UCS ta mới tìm được góc góc angmin. Ứng với góc angmin ta tìm được 1 điểm C -> thực hiện vòng lặp cho đến khi nào nó quay về điểm A (điểm tìm được đầu tiên).

Còn không xoay UCS thì Tue_NV bó tay, không biết làm cách nào?

 

Code đẫ được Tue_NV thể hiện ở bài viết trên (bài viết số 190)

Mong được sự giúp đỡ của các bác.

Tue_NV xin cảm ơn.

Chào Tue_NV

Như Thiep đã nói, không xoay hệ tọa độ thì tìm điểm kế tiếp vẫn được. Từ điểm B vừa tìm được vẫn tìm được điểm C.... Cứ thế cho đến khi điểm cuối trùng lại điểm A thì dừng. Tue_NV xem đoạn lisp sau:

;; free lisp from cadviet.com by thiep and Tue_nv
(defun gocmin (p lst / goc gmin pluu)
 (foreach p1 lst
   (setq goc (angle p p1))
   (if	(or (not gmin) (> gmin goc))
     (setq gmin goc
    pluu p1
     )
   )
 )
 pluu
)
;;;-------------------------------------------
(defun SS-aobjlst (ss / c L)
 (setq c -1)
 (repeat (sslength ss)
   (setq L (cons (vlax-ename->vla-object (ssname ss (setq c (1+ c))))
	  L
    )
   )
 )
 (reverse L)
)
;;;-------------------------------------------
(defun entmkLine (p1 p2)
 (entmake (list '(0 . "line")
	 (cons 10 p1)
	 (cons 11 p2)
   )
 )
)
;;;-------------------------------------------
(defun c:dglo (/ ss objlst tap_ins pd pc pt pchk1 Lst)
 (command "undo" "be")
 (command "ucs" "")
 (setq	ss	(ssget '((0 . "POINT")))
tap_ins	(list)
 )
 (setq	objlst (SS-aobjlst ss))
 (setq tap_ins (mapcar '(lambda (x) (vlax-get x 'Coordinates)) objlst))
 (setq tap_ins (mapcar '(lambda (x) (trans x 0 1)) tap_ins))
 (setq	tap_ins	(vl-sort tap_ins
		 '(lambda (x y)
		    (< (cadr x) (cadr y))
		  )
	)
 )
 (setq	pd    (car tap_ins)
pc    (last tap_ins)
pt    pd
pchk1 nil
 )
 (while (not (eq pchk1 pc))
   (setq lst (vl-remove pt tap_ins))
   (setq pchk1	(gocmin pt lst))
   (entmkLine pt pchk1)
   (setq pt pchk1)
 )
 (while (not (eq pchk1 pd))
   (setq lst (vl-remove pt tap_ins))
   (setq pchk1 (gocmin pt lst))
   (entmkLine pt pchk1)
   (setq pt pchk1)
   (foreach p tap_ins
     (if (<= (cadr pt) (cadr p))
(setq tap_ins (vl-remove p tap_ins))
     )
   )
 )
 (command "undo" "en")
 (princ)
)

Xin trao đổi cùng Tue: Trong lisp này Thiep thay đoạn mã: (mapcar 'vlax-ename->vla-object (vl-remove-if 'listp (mapcar 'cadr (ssnamex ss)))) bằng hàm SS-aobjlst. Thiep cho rằng nó sẽ chậm hơn vì hàm ssnamex nó đưa ra thông tin trong cơ sở dữ liệu của Cad nhiều hơn hàm ssname, vì vậy chiếm bộ nhớ nhiều hơn. Đoạn mã trên có thể Tue_nv tham khảo từ giabach vì giabach rất hay dùng, cũng có thể giabach tham khảo từ lisp break_with.lsp. Tuy nhiên trong lisp này, Thiep nhớ là tác giả cũng đã nói đến điều này mặc dù nó ngắn gọn hơn.

  • Vote tăng 1

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
.....................

Thiep cho rằng nó sẽ chậm hơn vì hàm ssnamex nó đưa ra thông tin trong cơ sở dữ liệu của Cad nhiều hơn hàm ssname, vì vậy chiếm bộ nhớ nhiều hơn. Đoạn mã trên có thể Tue_nv tham khảo từ giabach vì giabach rất hay dùng, cũng có thể giabach tham khảo từ lisp break_with.lsp. Tuy nhiên trong lisp này, Thiep nhớ là tác giả cũng đã nói đến điều này mặc dù nó ngắn gọn hơn.

Chính xác.

Tuy nhiên nếu Thiep để ý sẽ thấy các Lisp gần đây tui cũng không sử dụng hàm ssnamex nữa.

  • Vote tăng 1

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
Xin trao đổi cùng Tue: Trong lisp này Thiep thay đoạn mã: (mapcar 'vlax-ename->vla-object (vl-remove-if 'listp (mapcar 'cadr (ssnamex ss)))) bằng hàm SS-aobjlst. Thiep cho rằng nó sẽ chậm hơn vì hàm ssnamex nó đưa ra thông tin trong cơ sở dữ liệu của Cad nhiều hơn hàm ssname, vì vậy chiếm bộ nhớ nhiều hơn.

Thực ra với một lisp đơn giản thì hàm trên không làm mất hơn bao nhiều thời gian và bộ nhớ. Dùng ssnamex có một cái tiện là viết code ngắn gọn, không cần dùng đến hàm con. Nếu trong chương trình lớn thì để thể hiện chương trình một cách đơn giản, ngắn gọn, dễ hiểu người ta quan tâm đến rút ngắn tối đa dòng code và thuật toán tối ưu nhất. Vì thế việc dùng hàm con là rất quan trọng.

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
Chào Tue_NV

Như Thiep đã nói, không xoay hệ tọa độ thì tìm điểm kế tiếp vẫn được. Từ điểm B vừa tìm được vẫn tìm được điểm C.... Cứ thế cho đến khi điểm cuối trùng lại điểm A thì dừng. Tue_NV xem đoạn lisp sau:

;; free lisp from cadviet.com by thiep and Tue_nv
(defun gocmin (p lst / goc gmin pluu)
 (foreach p1 lst
   (setq goc (angle p p1))
   (if	(or (not gmin) (> gmin goc))
     (setq gmin goc
    pluu p1
     )
   )
 )
 pluu
)
;;;-------------------------------------------
(defun SS-aobjlst (ss / c L)
 (setq c -1)
 (repeat (sslength ss)
   (setq L (cons (vlax-ename->vla-object (ssname ss (setq c (1+ c))))
	  L
    )
   )
 )
 (reverse L)
)
;;;-------------------------------------------
(defun entmkLine (p1 p2)
 (entmake (list '(0 . "line")
	 (cons 10 p1)
	 (cons 11 p2)
   )
 )
)
;;;-------------------------------------------
(defun c:dglo (/ ss objlst tap_ins pd pc pt pchk1 Lst)
 (command "undo" "be")
 (command "ucs" "")
 (setq	ss	(ssget '((0 . "POINT")))
tap_ins	(list)
 )
 (setq	objlst (SS-aobjlst ss))
 (setq tap_ins (mapcar '(lambda (x) (vlax-get x 'Coordinates)) objlst))
 (setq tap_ins (mapcar '(lambda (x) (trans x 0 1)) tap_ins))
 (setq	tap_ins	(vl-sort tap_ins
		 '(lambda (x y)
		    (			  )
	)
 )
 (setq	pd    (car tap_ins)
pc    (last tap_ins)
pt    pd
pchk1 nil
 )
 (while (not (eq pchk1 pc))
   (setq lst (vl-remove pt tap_ins))
   (setq pchk1	(gocmin pt lst))
   (entmkLine pt pchk1)
   (setq pt pchk1)
 )
 (while (not (eq pchk1 pd))
   (setq lst (vl-remove pt tap_ins))
   (setq pchk1 (gocmin pt lst))
   (entmkLine pt pchk1)
   (setq pt pchk1)
   (foreach p tap_ins
     (if (	(setq tap_ins (vl-remove p tap_ins))
     )
   )
 )
 (command "undo" "en")
 (princ)
)

Xin trao đổi cùng Tue: Trong lisp này Thiep thay đoạn mã: (mapcar 'vlax-ename->vla-object (vl-remove-if 'listp (mapcar 'cadr (ssnamex ss)))) bằng hàm SS-aobjlst. Thiep cho rằng nó sẽ chậm hơn vì hàm ssnamex nó đưa ra thông tin trong cơ sở dữ liệu của Cad nhiều hơn hàm ssname, vì vậy chiếm bộ nhớ nhiều hơn. Đoạn mã trên có thể Tue_nv tham khảo từ giabach vì giabach rất hay dùng, cũng có thể giabach tham khảo từ lisp break_with.lsp. Tuy nhiên trong lisp này, Thiep nhớ là tác giả cũng đã nói đến điều này mặc dù nó ngắn gọn hơn.

Lời đầu tiên, Tue_NV xin cảm ơn bác Thiep. Code rất hay

Tuy nhiên nó bị 1 lỗi nhỏ.

Mình phải thay đoạn :

(setq tap_ins (vl-sort tap_ins

'(lambda (x y)

(

)

)

)

thành đoạn này : (setq tap_ins (vl-sort tap_ins

'(lambda (x y)

(if (= (cadr x) (cadr y))

(

(

)

)

)

)

 

thì mới đúng trong mọi trường hợp.

Cảm ơn bác nhiều.

 

Các bác cho Tue_NV hỏi thêm:

Mình có xem trên mạng thấy ví dụ có hàm setfon để thiết lập font chữ nhưng chưa hiểu về thông số này

(setq at (vla-get-activeTextStyle (vla-get-activedocument 
(vlax-get-acad-object))))
(vla-setfont at "ARIAL" :vlax-False :vlax-False 0 32)

-> Tue_NV chưa hiểu tham số 0 và tham số 32 có nghĩa là gì?

Đọc trong help thì số 0 chính là CharSet và 32 chính là PitchAndFamily

Tue_NV chưa hiểu rõ 2 tham số này.

Rất mong được sự giúp đỡ của các bác.

Xin chân thành cảm ơn.

  • Vote tăng 1

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
Các bác cho Tue_NV hỏi thêm:

Mình có xem trên mạng thấy ví dụ có hàm setfon để thiết lập font chữ nhưng chưa hiểu về thông số này

(setq at (vla-get-activeTextStyle (vla-get-activedocument 
(vlax-get-acad-object))))
(vla-setfont at "ARIAL" :vlax-False :vlax-False 0 32)

-> Tue_NV chưa hiểu tham số 0 và tham số 32 có nghĩa là gì?

Đọc trong help thì số 0 chính là CharSet và 32 chính là PitchAndFamily

Tue_NV chưa hiểu rõ 2 tham số này.

Rất mong được sự giúp đỡ của các bác.

Xin chân thành cảm ơn.

Bên cạnh vấn đề cần hỏi trên, Tue_NV có 1 bài toán thêm vào tập chọn đối tượng thao tác với Activex mà mình loay hoay mãi mà chưa giải quyết được. Nó cứ báo lỗi. Đây là code :

(defun c:addss(/ ssets ssobj)
(setq ssets (vla-get-selectionsets (vla-get-activedocument (vlax-get-acad-object)))) 
(setq ssobj (vla-add ssets "sel"))
(vla-SelectOnScreen ssobj)
(setq obj_add (vlax-ename->vla-object (car(entsel "\n Chon doi tuong add vao tap chon"))))
(vla-additems ssets (vlax-make-variant obj_add vlax-vbobject))
(vla-delete ssobj)
(princ)
)

Tue_NV muốn thêm một đối tượng obj_add vào tập chọn ssobj nhưng chạy Lisp xong thì báo lỗi error: ActiveX Server returned the error: unknown name: AddItems

Cái này mình chưa hiểu là bị lỗi gì mà Lisp lại báo rằng unknown name: AddItems làm vậy??

Xin các bác hướng dẫn giúp. và mình cũng muốn mở rộng thêm là thêm nhiều đối tượng chọn vào 1 tập chọn.

 

Rất mong sự giúp đỡ của các bác.

Xin chân thành cảm ơn.

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
Bên cạnh vấn đề cần hỏi trên, Tue_NV có 1 bài toán thêm vào tập chọn đối tượng thao tác với Activex mà mình loay hoay mãi mà chưa giải quyết được. Nó cứ báo lỗi. Đây là code :

(defun c:addss(/ ent ssets ssobj ss_array ss_list)
 (setq ssets (vla-get-selectionsets (vla-get-activedocument (vlax-get-acad-object))))
 (setq ssobj (vla-add ssets "sel"))
 (vla-SelectOnScreen ssobj)

 (while (setq ent (entsel "\n Chon doi tuong add vao tap chon"))
   (setq ss_list (cons (vlax-ename->vla-object (car ent)) ss_list)))

 (setq ss_array (vlax-make-safearray vlax-vbObject (cons 0 (- (length ss_list) 1))))
 (vlax-safearray-fill ss_array ss_list)
 (vlax-make-variant ss_array)

 (vla-additems ssobj ss_array)
 (vla-delete ssobj)
 (princ))

  • Vote tăng 1

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác

hay quá cảm ơn bác ssg dựa vào cái vẽ nhà của bác mình đã vẽ đươc ngôi sao nè thich thật.

thank bác nhiều nhe mình học tiếp đã

(defun c:sao(/ r p1 p2 p3 p4 p5 p6 OldOs)

(setq

p1 (getpoint "\n chon tam: ")

r (getint "\n ban kinh r= ")

p2 (polar p1 (/ pi 2) r)

p3 (polar p1 (/ pi 10) r)

p6 (polar p1 (* pi 0.9) r)

p5 (polar p1 (* pi 1.3) r)

p4 (polar p1 (* pi 1.7) r)

)

(setq OldOs (getvar "osmode"))

(setvar "osmode" 0)

(command "pline" p2 p4 p6 p3 p5 "c")

(setvar "osmode" OldOs)

(princ)

)

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác

Chào các bác! Em cũng đang tập tọe học lisp. Ngồi làm cái lisp vẽ hcn thôi mà khi load thì nó vẫn báo thiếu tham số. Tìm mãi không thấy chỗ sai. Mong các bác tìm giúp em với.

 

;;;------------------------------

(defun C:hcn(/a b p1 p2 p3 p4 oldos)

(Setq

a(getreal "\n chieu rong a= ")

b(getreal "\n chieu dai b= ")

p1(getpoint "\n diem chuan P1: ")

p2(polar p1 0.0 a)

p3(polar p2 (/ pi 2) B )

P4(polar p3 pi a)

)

(setq OldOs (getvar "osmode"))

(setvar "osmode" 0)

(command "line" p1 P2 p3 p4"c")

(setvar "osmode" OldOs)

(princ)

)

;;;------------------------------

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
Chào các bác! Em cũng đang tập tọe học lisp. Ngồi làm cái lisp vẽ hcn thôi mà khi load thì nó vẫn báo thiếu tham số. Tìm mãi không thấy chỗ sai. Mong các bác tìm giúp em với.

 

;;;------------------------------

(defun C:hcn(/a b p1 p2 p3 p4 oldos)

(Setq

a(getreal "\n chieu rong a= ")

b(getreal "\n chieu dai b= ")

p1(getpoint "\n diem chuan P1: ")

p2(polar p1 0.0 a)

p3(polar p2 (/ pi 2) B )

P4(polar p3 pi a)

)

(setq OldOs (getvar "osmode"))

(setvar "osmode" 0)

(command "line" p1 P2 p3 p4"c")

(setvar "osmode" OldOs)

(princ)

)

;;;------------------------------

Bạn sai chổ này :

(defun C:hcn(/a b p1 p2 p3 p4 oldos)

Phải có khoảng trắng giữa / và biến a -> Bạn viết liền nhau thành ra bị lỗi

-> Sửa lại là :

(defun C:hcn(/ a b p1 p2 p3 p4 oldos)

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
Bạn sai chổ này :

(defun C:hcn(/a b p1 p2 p3 p4 oldos)

Phải có khoảng trắng giữa / và biến a -> Bạn viết liền nhau thành ra bị lỗi

-> Sửa lại là :

(defun C:hcn(/ a b p1 p2 p3 p4 oldos)

Thanks bác nhiều nhé. Bác tinh thật đấy.

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
Lệnh để vẽ Arc với Start End Angle dùng cho Lisp là gì vậy các Bác ơi? Thanks.

Chào bác Phiphi-,

Bác thử xài (command "arc" pause) xem sao bác nhé.

Chúc bác vui.

  • Vote tăng 1

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
Chào bác Phiphi-,

Bác thử xài (command "arc" pause) xem sao bác nhé.

Chúc bác vui.

Vẽ Arc trong AutoCAD có đến 9 kiểu khác nhau Bác ạ. PP cần vẽ là Arc kiểu Start End Angle với Angle=25 độ.

(command "arc" pause) thì không xác định đúng kiểu User muốn.

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
Vẽ Arc trong AutoCAD có đến 9 kiểu khác nhau Bác ạ. PP cần vẽ là Arc kiểu Start End Angle với Angle=25 độ.

(command "arc" pause) thì không xác định đúng kiểu User muốn.

Phiphi thử cái này :

(defun C:asea(/ p)
(vl-load-com)
(setq p (getpoint "\n Nhap diem dau :"))
(vl-cmdf "arc" p 
"e" 
(getpoint p "\n Nhap diem cuoi :")  
"a" pause (princ "\n Nhap goc :"))
(princ)
)

  • Vote tăng 1

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
Vẽ Arc trong AutoCAD có đến 9 kiểu khác nhau Bác ạ. PP cần vẽ là Arc kiểu Start End Angle với Angle=25 độ.

(command "arc" pause) thì không xác định đúng kiểu User muốn.

Thử xem:

(command "arc" pause "e" pause "a" pause)

  • Vote tăng 2

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
Vẽ Arc trong AutoCAD có đến 9 kiểu khác nhau Bác ạ. PP cần vẽ là Arc kiểu Start End Angle với Angle=25 độ.

(command "arc" pause) thì không xác định đúng kiểu User muốn.

Hề hề hề,

Cái này vẫn được chứ bác nhể, này nhé sau khi lisp nó pause rồi thì trên dòng nhắc command của CAD xuất hiện:

Specify start point of arc or (Center): Bác chỉ việc pick một phát để chọn điểm đầu của cung.

Khi đó trên dòng command lại xuất hiện: Specify second point of arc or (Center/End): Bác gõ vào e rối Enter

Và trên dòng command lại nhắc: Specify end point of arc: Bác pick một phát nữa lấy điểm cuối của cung.

Khi dó trên dòng command lại nhắc: Specify center point of arc or (Angle/Direction/Radius): Bác gõ vào a rồi Enter

Và trên dòng command lại nhắc: Specify included angle: Bác chỉ việc nhập góc của cung vào ví dụ 30 là OK mà lị.

 

Dù có bao nhiêu kiểu đi nữa nhưng với cái khúc lisp của mình nếu bác nắm vững cách vẽ của từng kiểu thì bác cứ yên trí mà vẽ theo kiểu bác muốn. Start End Angle hay Start Second End hay ......

 

Nếu bác chỉ sử dụng độc một kiểu Start End Angle thì cái lisp của bác Tue_NV là OK rùi.

  • Vote tăng 1

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
Hề hề hề,

...

Dù có bao nhiêu kiểu đi nữa nhưng với cái khúc lisp của mình nếu bác nắm vững cách vẽ của từng kiểu thì bác cứ yên trí mà vẽ theo kiểu bác muốn. Start End Angle hay Start Second End hay ......

Hề hề hề, hay... bác gõ chữ arc vào dòng sông command là xong chứ cần gì đến Lisp

Vì (command "arc" pause) chính là gõ arc vào dòng command vậy

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác

Tạo một tài khoản hoặc đăng nhập để nhận xét

Bạn cần phải là một thành viên để lại một bình luận

Tạo tài khoản

Đăng ký một tài khoản mới trong cộng đồng của chúng tôi. Điều đó dễ mà.

Đăng ký tài khoản mới

Đăng nhập

Bạn có sẵn sàng để tạo một tài khoản ? Đăng nhập tại đây.

Đăng nhập ngay


×